var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import axios from 'axios';
import iconv from 'iconv-lite';
import fs from 'fs';
import path from 'path';
import util from 'util';
import ora from 'ora';
import chalk from 'chalk';
import { Scheduler, retryFn } from './utils/Scheduler.js';
import { fetch } from './utils/fetch.js';
import Epub from 'epub-gen-memory';
var BASE_URL = 'https://www.wenku8.net/book/';
var spinner = ora();
var scheduler = new Scheduler(5);
var writeFile = util.promisify(fs.writeFile);
var appendFile = util.promisify(fs.appendFile);
/**
 * 根据小说ID，下载全部小说
 * @param novelId
 * @param options
 */
export function downloadNovel(novelId, options) {
    return __awaiter(this, void 0, void 0, function () {
        var endCount, errorTimes_1, novel_1, epubOptions_1, _a, volumes, volumeMap, amount_1, count_1, _loop_1, volumes_1, volumes_1_1, volume, _b, minutes, seconds, file, error_1;
        var e_1, _c;
        var _this = this;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _d.trys.push([0, 8, , 9]);
                    if (!fs.existsSync(path.join(process.cwd(), options.outDir))) {
                        fs.mkdirSync(path.join(process.cwd(), options.outDir));
                    }
                    endCount = startCount();
                    errorTimes_1 = 0;
                    spinner.start('正在获取小说详情');
                    return [4 /*yield*/, getNovelDetails(novelId)];
                case 1:
                    novel_1 = _d.sent();
                    epubOptions_1 = {
                        title: novel_1.novelName,
                        author: novel_1.author,
                        cover: novel_1.cover,
                        tocTitle: '目录',
                        lang: 'cn',
                        content: [],
                        verbose: options.verbose,
                        fetchTimeout: 2000,
                        retryTimes: 10,
                        batchSize: 5,
                        ignoreFailedDownloads: !options.strict,
                    };
                    if (!novel_1.catalogueUrl) return [3 /*break*/, 7];
                    return [4 /*yield*/, getChapterList(novel_1.catalogueUrl)];
                case 2:
                    _a = _d.sent(), volumes = _a.volumes, volumeMap = _a.volumeMap, amount_1 = _a.amount;
                    count_1 = 0;
                    spinner.succeed("\u6210\u529F\u83B7\u53D6\u5C0F\u8BF4\u8BE6\u60C5\uFF0C\u8BE5\u5C0F\u8BF4\u5171\u6709".concat(volumes.length, "\u5377"));
                    _loop_1 = function (volume) {
                        var e_2, _e;
                        var volumeNameWithIndex = "".concat(volume.index + 1, "-").concat(volume.name);
                        if (options.epub) {
                            epubOptions_1.content.push({
                                title: volume.name,
                                content: [],
                            });
                        }
                        else {
                            if (!fs.existsSync(path.join(process.cwd(), options.outDir, novel_1.novelName, volumeNameWithIndex))) {
                                fs.mkdirSync(path.join(process.cwd(), options.outDir, novel_1.novelName, volumeNameWithIndex, '插图'), {
                                    recursive: true,
                                });
                            }
                        }
                        var chapters = volumeMap.get(volume.name);
                        if (chapters) {
                            var _loop_2 = function (chapterIndex, chapterTitle, chapterUrl) {
                                scheduler.add(function () { return __awaiter(_this, void 0, void 0, function () {
                                    var _a, content, images, paths, _loop_3, images_1, images_1_1, imageUrl, error_2;
                                    var e_3, _b;
                                    var _this = this;
                                    return __generator(this, function (_c) {
                                        switch (_c.label) {
                                            case 0:
                                                _c.trys.push([0, 5, , 6]);
                                                if (!options.onlyImages) {
                                                    spinner.start("\u6B63\u5728\u4E0B\u8F7D\uFF1A" +
                                                        chalk.bold.black.bgWhite(" ".concat(count_1 + 1, "/").concat(amount_1, " ")) +
                                                        chalk.blue.bold("".concat(volume.name, "\u3001").concat(chapterTitle)));
                                                }
                                                return [4 /*yield*/, retryFn(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                                        return [2 /*return*/, downloadChapter(chapterUrl, options)];
                                                    }); }); })];
                                            case 1:
                                                _a = _c.sent(), content = _a.content, images = _a.images;
                                                paths = [];
                                                if (images.length) {
                                                    _loop_3 = function (imageUrl) {
                                                        var imagePath = imageUrl.split('/').pop();
                                                        paths.push(imagePath);
                                                        if (!options.epub) {
                                                            scheduler.add(function () { return __awaiter(_this, void 0, void 0, function () {
                                                                var res, _a;
                                                                var _this = this;
                                                                return __generator(this, function (_b) {
                                                                    switch (_b.label) {
                                                                        case 0:
                                                                            _b.trys.push([0, 2, , 3]);
                                                                            spinner.start("".concat(volume.name, "-").concat(chapterTitle, "-").concat(imagePath, "\u4E0B\u8F7D\u4E2D"));
                                                                            return [4 /*yield*/, retryFn(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                                                                    return [2 /*return*/, axios.get(imageUrl, { responseType: 'arraybuffer' })];
                                                                                }); }); })];
                                                                        case 1:
                                                                            res = _b.sent();
                                                                            spinner.succeed("".concat(volume.name, "-").concat(chapterTitle, "-").concat(imagePath, "\u4E0B\u8F7D\u5B8C\u6210"));
                                                                            return [2 /*return*/, writeFile(path.join(process.cwd(), options.outDir, novel_1.novelName, volumeNameWithIndex, "./\u63D2\u56FE/".concat(imagePath)), res.data)];
                                                                        case 2:
                                                                            _a = _b.sent();
                                                                            errorTimes_1++;
                                                                            console.log(chalk.red("".concat(volume.name, "-").concat(chapterTitle, "-").concat(imagePath, "\u4E0B\u8F7D\u5931\u8D25")));
                                                                            return [2 /*return*/, appendFile(path.join(process.cwd(), 'wenku8-error.log'), "".concat(volume.name, "-").concat(chapterTitle, "-").concat(imagePath, "\u4E0B\u8F7D\u5931\u8D25, \u94FE\u63A5\u5730\u5740\uFF1A").concat(imageUrl, "\n"))];
                                                                        case 3: return [2 /*return*/];
                                                                    }
                                                                });
                                                            }); });
                                                        }
                                                    };
                                                    try {
                                                        for (images_1 = __values(images), images_1_1 = images_1.next(); !images_1_1.done; images_1_1 = images_1.next()) {
                                                            imageUrl = images_1_1.value;
                                                            _loop_3(imageUrl);
                                                        }
                                                    }
                                                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                                                    finally {
                                                        try {
                                                            if (images_1_1 && !images_1_1.done && (_b = images_1.return)) _b.call(images_1);
                                                        }
                                                        finally { if (e_3) throw e_3.error; }
                                                    }
                                                }
                                                if (!options.epub) return [3 /*break*/, 2];
                                                epubOptions_1.content[volume.index].content[chapterIndex] =
                                                    "<h1>".concat(chapterTitle, "</h1>") + content;
                                                return [3 /*break*/, 4];
                                            case 2:
                                                if (!!options.onlyImages) return [3 /*break*/, 4];
                                                return [4 /*yield*/, writeFile(path.join(process.cwd(), options.outDir, novel_1.novelName, volumeNameWithIndex, "".concat(chapterIndex, "-").concat(chapterTitle, ".").concat(options.ext)), "# ".concat(chapterTitle, "\n") +
                                                        content +
                                                        paths.map(function (path) { return "![](./\u63D2\u56FE/".concat(path, ")"); }).join('\n'))];
                                            case 3:
                                                _c.sent();
                                                _c.label = 4;
                                            case 4:
                                                if (!options.onlyImages) {
                                                    spinner.succeed("\u4E0B\u8F7D\u6210\u529F\uFF1A" +
                                                        chalk.bold.black.bgGreen(" ".concat(count_1 + 1, "/").concat(amount_1, " ")) +
                                                        chalk.blue.bold("".concat(volume.name, "\u3001").concat(chapterTitle)));
                                                }
                                                count_1++;
                                                return [3 /*break*/, 6];
                                            case 5:
                                                error_2 = _c.sent();
                                                errorTimes_1++;
                                                count_1++;
                                                console.log(chalk.red("".concat(chapterTitle, "\u4E0B\u8F7D\u5931\u8D25")));
                                                return [2 /*return*/, appendFile(path.join(process.cwd(), 'wenku8-error.log'), "".concat(chapterTitle, "\u4E0B\u8F7D\u5931\u8D25, \u94FE\u63A5\u5730\u5740\uFF1A").concat(chapterUrl))];
                                            case 6: return [2 /*return*/];
                                        }
                                    });
                                }); });
                            };
                            try {
                                for (var chapters_1 = (e_2 = void 0, __values(chapters)), chapters_1_1 = chapters_1.next(); !chapters_1_1.done; chapters_1_1 = chapters_1.next()) {
                                    var _f = chapters_1_1.value, chapterIndex = _f.chapterIndex, chapterTitle = _f.chapterTitle, chapterUrl = _f.chapterUrl;
                                    _loop_2(chapterIndex, chapterTitle, chapterUrl);
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (chapters_1_1 && !chapters_1_1.done && (_e = chapters_1.return)) _e.call(chapters_1);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                        }
                    };
                    try {
                        for (volumes_1 = __values(volumes), volumes_1_1 = volumes_1.next(); !volumes_1_1.done; volumes_1_1 = volumes_1.next()) {
                            volume = volumes_1_1.value;
                            _loop_1(volume);
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (volumes_1_1 && !volumes_1_1.done && (_c = volumes_1.return)) _c.call(volumes_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    return [4 /*yield*/, scheduler.onFinish()];
                case 3:
                    _d.sent();
                    _b = endCount(), minutes = _b.minutes, seconds = _b.seconds;
                    if (!options.epub) return [3 /*break*/, 6];
                    spinner.start("\u6B63\u5728\u751F\u6210epub\u7535\u5B50\u4E66\uFF0C\u8BF7\u7A0D\u7B49...");
                    return [4 /*yield*/, Epub.default(epubOptions_1, epubOptions_1.content.map(function (item) { return (__assign(__assign({}, item), { content: item.content.join("\n\n\n\n\n") })); }))];
                case 4:
                    file = _d.sent();
                    return [4 /*yield*/, writeFile(path.join(process.cwd(), options.outDir, "".concat(novel_1.novelName, ".epub")), file)];
                case 5:
                    _d.sent();
                    spinner.stop();
                    _d.label = 6;
                case 6:
                    console.log(chalk.bold.green("\u300E ".concat(novel_1.novelName, " \u300F") + '下载完成!' + "\u603B\u5171\u7528\u65F6".concat(minutes, "\u5206").concat(seconds, "\u79D2")));
                    if (errorTimes_1) {
                        console.log(chalk.yellow("\u672C\u6B21\u4E0B\u8F7D\u4E2D\u51FA\u73B0\u4E86".concat(errorTimes_1, "\u6B21\u9519\u8BEF\uFF0C\u8BE6\u60C5\u89C1\u65E5\u5FD7\u6587\u4EF6wenku8-error.log")));
                    }
                    _d.label = 7;
                case 7: return [3 /*break*/, 9];
                case 8:
                    error_1 = _d.sent();
                    console.log(error_1);
                    return [3 /*break*/, 9];
                case 9: return [2 /*return*/];
            }
        });
    });
}
/**
 * 根据小说的目录页，获取所有章节
 * @param catalogueUrl
 * @returns
 */
function getChapterList(catalogueUrl) {
    return __awaiter(this, void 0, void 0, function () {
        function insertMap(start, end, volumeName) {
            rows.slice(start, end)
                .find('a')
                .each(function (chapterIndex, item) {
                var chapterTitle = $(item).text();
                var chapterUrl = $(item).attr('href');
                if (chapterUrl) {
                    volumeMap.set(volumeName, __spreadArray(__spreadArray([], __read((volumeMap.get(volumeName) || [])), false), [
                        {
                            chapterIndex: chapterIndex + 1,
                            chapterTitle: chapterTitle,
                            chapterUrl: catalogueUrl.replace(/index\.htm$/, chapterUrl),
                        },
                    ], false));
                }
            });
        }
        var $, rows, volumes, volumeMap;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetch(catalogueUrl)];
                case 1:
                    $ = _a.sent();
                    rows = $('tbody').children();
                    volumes = $('table td[colspan=4]')
                        .map(function (index, item) { return ({
                        index: index,
                        name: $(item).text(),
                        rowNumber: $(item).parent().index(),
                    }); })
                        .get();
                    volumeMap = new Map();
                    volumes.reduce(function (prev, next) {
                        insertMap(prev.rowNumber, next.rowNumber, prev.name);
                        return next;
                    });
                    insertMap(volumes[volumes.length - 1].rowNumber, rows.length, volumes[volumes.length - 1].name);
                    return [2 /*return*/, {
                            volumes: volumes,
                            volumeMap: volumeMap,
                            amount: Array.from(volumeMap.values()).flat().length,
                        }];
            }
        });
    });
}
/**
 * 下载某一章节
 * @param chapterUrl
 * @returns
 */
function downloadChapter(chapterUrl, options) {
    var _a, _b, _c;
    return __awaiter(this, void 0, void 0, function () {
        var $, content_1, v, $_1, error_3, res, picReg, picRegL, images_2, content, images;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, fetch(chapterUrl)];
                case 1:
                    $ = _d.sent();
                    if (!($('#contentmain span').first().text().trim() == 'null')) return [3 /*break*/, 8];
                    content_1 = '';
                    v = chapterUrl.substring(0, chapterUrl.lastIndexOf('.')).split('/');
                    _d.label = 2;
                case 2:
                    _d.trys.push([2, 4, , 7]);
                    return [4 /*yield*/, fetch("http://dl.wenku8.com/pack.php?aid=".concat(v.slice(-2)[0], "&vid=").concat(v.slice(-1)[0]), 'utf-8')];
                case 3:
                    $_1 = _d.sent();
                    content_1 =
                        ((_a = (options.epub ? $_1('body').html() : $_1('body').text())) === null || _a === void 0 ? void 0 : _a.replace('&nbsp;', '').replace('更多精彩热门日本轻小说、动漫小说，轻小说文库(http://www.wenku8.com) 为你一网打尽！', '')) || '';
                    return [3 /*break*/, 7];
                case 4:
                    error_3 = _d.sent();
                    if (!(error_3.message.indexOf('404') !== -1)) return [3 /*break*/, 6];
                    return [4 /*yield*/, axios.get("http://dl.wenku8.com/packtxt.php?aid=".concat(v.slice(-2)[0], "&vid=").concat(v.slice(-1)[0]), {
                            responseType: 'arraybuffer',
                        })];
                case 5:
                    res = _d.sent();
                    content_1 = iconv.decode(res.data, 'utf-8');
                    _d.label = 6;
                case 6: return [3 /*break*/, 7];
                case 7:
                    picReg = /http:\/\/pic\.wenku8\.com\/pictures\/[\/0-9]+.jpg/g;
                    picRegL = /http:\/\/pic\.wenku8\.com\/pictures\/[\/0-9]+.jpg\([0-9]+K\)/g;
                    images_2 = (_b = content_1.match(picReg)) !== null && _b !== void 0 ? _b : [];
                    content_1 = content_1.replace(picRegL, '');
                    return [2 /*return*/, {
                            content: content_1,
                            images: images_2,
                        }];
                case 8:
                    content = (_c = (options.epub ? $('#content').html() : $('#content').text())) === null || _c === void 0 ? void 0 : _c.replace('本文来自 轻小说文库(http://www.wenku8.com)', '').replace('台版 转自 轻之国度', '').replace('最新最全的日本动漫轻小说 轻小说文库(http://www.wenku8.com) 为你一网打尽！', '');
                    images = $('img')
                        .map(function (i, imgEle) {
                        var src = imgEle.attribs.src;
                        return src;
                    })
                        .get();
                    return [2 /*return*/, {
                            content: content,
                            images: images,
                        }];
            }
        });
    });
}
/**
 * 获取小说详细信息
 * @param novelId
 * @returns
 */
export function getNovelDetails(novelId) {
    return __awaiter(this, void 0, void 0, function () {
        var $, novelName, _a, library, author, status, lastUpdateTime, length, cover, centerEl, tag, recentChapter, desc, catalogueUrl;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, fetch("".concat(BASE_URL).concat(novelId, ".htm"))];
                case 1:
                    $ = _b.sent();
                    novelName = $('#content').children().first().children().first().find('table tbody tr td span b').text();
                    _a = __read($('#content')
                        .children()
                        .first()
                        .children()
                        .first()
                        .children()
                        .first()
                        .children()
                        .eq(1)
                        .children()
                        .map(function (i, item) {
                        return $(item)
                            .text()
                            .match(/：(.+)$/)[1];
                    })
                        .get(), 5), library = _a[0], author = _a[1], status = _a[2], lastUpdateTime = _a[3], length = _a[4];
                    cover = $('#content').children().first().children().eq(3).find('table tbody tr td img').attr('src');
                    centerEl = $('#content').children().first().children().eq(3).find('table tbody tr td').eq(1);
                    tag = centerEl
                        .find('span')
                        .first()
                        .text()
                        .match(/：(.+)$/)[1];
                    recentChapter = centerEl.find('span').eq(3).text();
                    desc = centerEl.find('span').last().text();
                    catalogueUrl = $('#content')
                        .children()
                        .first()
                        .children()
                        .eq(5)
                        .children()
                        .children()
                        .first()
                        .find('a')
                        .attr('href');
                    return [2 /*return*/, {
                            novelId: novelId,
                            novelName: novelName,
                            cover: cover,
                            library: library,
                            author: author,
                            status: status,
                            lastUpdateTime: lastUpdateTime,
                            length: length,
                            tag: tag,
                            recentChapter: recentChapter,
                            desc: desc,
                            catalogueUrl: catalogueUrl,
                        }];
            }
        });
    });
}
/**
 * 根据小说名称或者作者名称，获取到小说列表
 */
export function search(search, type) {
    if (type === void 0) { type = 'articlename'; }
    return __awaiter(this, void 0, void 0, function () {
        var searchKey, $, catalogueUrl, novelName, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    searchKey = __spreadArray([], __read(iconv.encode(search, 'gbk')), false).map(function (i) { return "%".concat(i.toString(16)); }).join('');
                    return [4 /*yield*/, fetch("https://www.wenku8.net/modules/article/search.php?searchtype=".concat(type, "&searchkey=").concat(searchKey))];
                case 1:
                    $ = _a.sent();
                    catalogueUrl = $('#content')
                        .children()
                        .first()
                        .children()
                        .eq(5)
                        .children()
                        .children()
                        .first()
                        .find('a')
                        .attr('href');
                    if (catalogueUrl) {
                        novelName = $('#content').children().first().children().first().find('table tbody tr td span b').text();
                        return [2 /*return*/, [{ novelName: novelName, novelId: +catalogueUrl.match(/(\d+)\/index\.htm$/)[1] }]];
                    }
                    result = $('tbody tr td')
                        .children()
                        .map(function (_i, item) {
                        var novelName = $(item).find('b').text();
                        var href = $(item).find('b a').attr('href');
                        var novelId = extractNovelIdFromUrl(href);
                        return {
                            novelName: novelName,
                            novelId: novelId,
                        };
                    })
                        .get();
                    return [2 /*return*/, result];
            }
        });
    });
}
/**
 * 获取热门小说列表
 */
export function getHotList() {
    return __awaiter(this, void 0, void 0, function () {
        function aliasRight(index) {
            switch (index) {
                case 0: {
                    return '今日热榜';
                }
                case 1: {
                    return '本月热榜';
                }
                case 2: {
                    return '最受关注';
                }
                case 3: {
                    return '已动画化';
                }
                case 4: {
                    return '最新入库';
                }
                default: {
                    throw new Error('异常');
                }
            }
        }
        function aliasCenters(index) {
            switch (index) {
                case 0: {
                    return '新番原作';
                }
                case 1: {
                    return '新书风云榜';
                }
                case 2: {
                    return '本周会员推荐';
                }
                default: {
                    throw new Error('异常');
                }
            }
        }
        var $, rightResult, centersResult;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetch('https://www.wenku8.net/index.php')];
                case 1:
                    $ = _a.sent();
                    rightResult = $('body')
                        .children()
                        .eq(4)
                        .find('#right')
                        .children()
                        .map(function (index, item) {
                        var novels = $(item)
                            .find('ul a')
                            .map(function (_i, item) {
                            var novelName = $(item).attr('title');
                            var href = $(item).attr('href');
                            var novelId = extractNovelIdFromUrl(href);
                            return {
                                novelName: "".concat(novelId, ".").concat(novelName),
                                novelId: novelId,
                            };
                        })
                            .get();
                        return {
                            type: aliasRight(index),
                            novels: novels,
                        };
                    })
                        .get();
                    centersResult = $('body')
                        .children()
                        .eq(4)
                        .find('#centers')
                        .children()
                        .slice(1, 4)
                        .map(function (index, item) {
                        var novels = $(item)
                            .find('a[title]')
                            .map(function (_i, item) {
                            var href = $(item).attr('href');
                            var novelName = $(item).attr('title');
                            var novelId = extractNovelIdFromUrl(href);
                            return {
                                novelName: "".concat(novelId, ".").concat(novelName),
                                novelId: novelId,
                            };
                        })
                            .get();
                        return {
                            type: aliasCenters(index),
                            novels: novels,
                        };
                    })
                        .get();
                    return [2 /*return*/, __spreadArray(__spreadArray([], __read(centersResult), false), __read(rightResult), false)];
            }
        });
    });
}
function extractNovelIdFromUrl(href) {
    return +href.match(/(\d+)\.htm$/)[1];
}
/**
 * 计时器
 * @returns
 */
function startCount() {
    var startTime = Date.now();
    return function () {
        var endTime = Date.now();
        var duration = endTime - startTime;
        var minutes = (duration / 1000 / 60).toFixed();
        var seconds = ((duration / 1000) % 60).toFixed();
        return {
            duration: duration,
            minutes: minutes,
            seconds: seconds,
        };
    };
}
